package weakcache;

import java.util.ArrayList;
import java.util.Collection;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class TaskExecutor {
    private final int numThreads;

    public TaskExecutor(int numThreads) {
        this.numThreads = numThreads;
    }

    public void submitTaskNTimesAndCaptureException(Runnable task, int times) {
        ExecutorService taskExecutor = Executors.newFixedThreadPool(numThreads);
        try {
            Collection<Future<?>> taskFutures = new ArrayList<Future<?>>();
            for (int i = 0; i < times; i++) {
                taskFutures.add(taskExecutor.submit(task));
            }

            for (Future<?> result : taskFutures) {
                result.get();
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        } finally {
            taskExecutor.shutdown();
        }
    }
}
