package weakcache;


import java.io.IOException;
import java.io.InvalidClassException;
import java.io.ObjectInputStream;
import java.lang.reflect.Proxy;
import java.util.concurrent.ExecutionException;

public class WeakCacheLowLevelTest {
    public static void main(String[] args) throws ExecutionException, InterruptedException, IOException, ClassNotFoundException {
        TaskExecutor executor = new TaskExecutor(4);
        while (true) {
            executor.submitTaskNTimesAndCaptureException(new RunJavaProcessAndCaptureException(WeakCacheHighLevelTest.class.getName() + "$Runner"), 4);
        }
    }

    public static class Runner {
        private static String[] ifaces = new String[]{"java.rmi.Remote"};

        public static void main(String[] args) throws IOException, ExecutionException, InterruptedException {
            new TaskExecutor(10).submitTaskNTimesAndCaptureException(new SimpleTask(), 10);
        }

        static class SimpleTask implements Runnable {
            @Override
            public void run() {
                try {
                    new ObjectInputStreamRaceCondition().provoke();
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
            }

            static class ObjectInputStreamRaceCondition extends ObjectInputStream {
                private ObjectInputStreamRaceCondition() throws IOException, SecurityException {
                }

                private void provoke() throws IOException, ClassNotFoundException {
                    Class cl;
                    if ((cl = resolveProxyClass(ifaces)) == null) {
                        throw new ClassNotFoundException("null class");
                    } else if (!Proxy.isProxyClass(cl)) {
                        throw new InvalidClassException("Not a proxy");
                    }
                }
            }
        }
    }
}
